Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90	(revision 11423)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfcavmlt.F90	(revision 11425)
@@ -57,14 +57,14 @@
       SELECT CASE ( cn_isfcav_mlt )
       CASE ( 'spe' )   ! ice shelf melt specified (read input file, and heat fluxes derived from
-         CALL isfmlt_spe( kt, pstbl,               &
+         CALL isfcav_mlt_spe( kt, pstbl,               &
             &                  pqhc, pqoce, pqfwf  )
       CASE ( '2eq' )   !  ISOMIP  formulation (2 equations) for volume flux (Hunter et al., 2006)
-         CALL isfmlt_2eq( pgt, pttbl, pstbl,       &
+         CALL isfcav_mlt_2eq( pgt, pttbl, pstbl,       &
             &                  pqhc , pqoce, pqfwf )
       CASE ( '3eq' )   ! ISOMIP+ formulation (3 equations) for volume flux (Asay-Davis et al., 2015)
-         CALL isfmlt_3eq( pgt, pgs , pttbl, pstbl, &
+         CALL isfcav_mlt_3eq( pgt, pgs , pttbl, pstbl, &
             &                  pqhc, pqoce, pqfwf  )
       CASE ( 'oasis' ) ! fwf pass trough oasis
-         CALL isfmlt_oasis( kt, pstbl,              &
+         CALL isfcav_mlt_oasis( kt, pstbl,              &
             &                   pqhc, pqoce, pqfwf  )
       CASE DEFAULT
@@ -78,5 +78,5 @@
 ! -------------------------------------------------------------------------------------------------------
 
-   SUBROUTINE isfmlt_spe(kt, pstbl,              &  ! <<== in
+   SUBROUTINE isfcav_mlt_spe(kt, pstbl,              &  ! <<== in
       &                      pqhc , pqoce, pqfwf )  ! ==>> out
       !!----------------------------------------------------------------------
@@ -106,7 +106,7 @@
       pqhc (:,:) =   pqfwf(:,:) * ztfrz(:,:) * rcp     ! heat content flux  ( >0 out)
       !
-   END SUBROUTINE isfmlt_spe
-
-   SUBROUTINE isfmlt_2eq(pgt, pttbl, pstbl,       &  ! <<== in
+   END SUBROUTINE isfcav_mlt_spe
+
+   SUBROUTINE isfcav_mlt_2eq(pgt, pttbl, pstbl,       &  ! <<== in
       &                       pqhc , pqoce, pqfwf )  ! ==>> out
       !!----------------------------------------------------------------------
@@ -147,7 +147,7 @@
       CALL iom_put('isfthermald_cav', zthd )
       !
-   END SUBROUTINE isfmlt_2eq
-
-   SUBROUTINE isfmlt_3eq(pgt, pgs , pttbl, pstbl, &
+   END SUBROUTINE isfcav_mlt_2eq
+
+   SUBROUTINE isfcav_mlt_3eq(pgt, pgs , pttbl, pstbl, &
       &                       pqhc, pqoce, pqfwf  )
       !!----------------------------------------------------------------------
@@ -229,7 +229,7 @@
       CALL iom_put('isfthermald_cav', zthd)
       !
-   END SUBROUTINE isfmlt_3eq
-
-   SUBROUTINE isfmlt_oasis(kt, pstbl,              &  ! <<== in
+   END SUBROUTINE isfcav_mlt_3eq
+
+   SUBROUTINE isfcav_mlt_oasis(kt, pstbl,              &  ! <<== in
       &                        pqhc , pqoce, pqfwf )  ! ==>> out
       !!----------------------------------------------------------------------
@@ -263,8 +263,10 @@
       !
       ! compute glob sum from input file
-      zfwf_fld = glob_sum('isfcav_mlt', zfwf(:,:))
+      ! (PM) should consider delay sum as in fwb (1 time step offset if I well understood)
+      zfwf_fld = glob_sum('isfcav_mlt', e1e2t(:,:) * zfwf(:,:))
       !
       ! compute glob sum from atm->oce ice shelf fwf
-      zfwf_oasis = glob_sum('isfcav_mlt', fwfisf_oasis(:,:))
+      ! (PM) should consider delay sum as in fwb (1 time step offset if I well understood)
+      zfwf_oasis = glob_sum('isfcav_mlt', e1e2t(:,:) * fwfisf_oasis(:,:))
       !
       ! scale fwf
@@ -277,5 +279,5 @@
       pqhc (:,:) =   pqfwf(:,:) * ztfrz(:,:) * rcp     ! heat content flux  ( >0 out)
       !
-   END SUBROUTINE isfmlt_oasis
+   END SUBROUTINE isfcav_mlt_oasis
 
    !SUBROUTINE isfmlt_3eq_frz_ktm1
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90	(revision 11423)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfparmlt.F90	(revision 11425)
@@ -192,8 +192,10 @@
       !
       ! compute glob sum from input file
-      zfwf_fld = glob_sum('isfcav_mlt', zfwf(:,:))
+      ! (PM) should we consider delay sum as in fwb ? (it will offset by 1 time step if I understood well)
+      zfwf_fld = glob_sum('isfcav_mlt', e1e2t(:,:) * zfwf(:,:))
       !
       ! compute glob sum from atm->oce ice shelf fwf
-      zfwf_oasis = glob_sum('isfcav_mlt', fwfisf_oasis(:,:))
+      ! (PM) should we consider delay sum as in fwb ?
+      zfwf_oasis = glob_sum('isfcav_mlt', e1e2t(:,:) * fwfisf_oasis(:,:))
       !
       ! scale fwf
Index: NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90
===================================================================
--- NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90	(revision 11423)
+++ NEMO/branches/2019/ENHANCE-02_ISF_nemo/src/OCE/ISF/isfstp.F90	(revision 11425)
@@ -267,4 +267,6 @@
          IF( lwxios ) CALL iom_set_rstw_var_active('ssmask')
          IF( lwxios ) CALL iom_set_rstw_var_active('tmask')
+         !IF( lwxios ) CALL iom_set_rstw_var_active('wmask')
+         !IF( lwxios ) CALL iom_set_rstw_var_active('gdepw_n')
          IF( lwxios ) CALL iom_set_rstw_var_active('e3t_n')
          IF( lwxios ) CALL iom_set_rstw_var_active('e3u_n')